#include "reader_sim.h"


void reader_sim::getOptions(argStruct *arguments){
  //  fprintf(stderr,"asdf:%p\n",arguments->argumentFile);
  fname=angsd::getArg("-sim1",fname,arguments);
  
  if(strcmp(fname,"-999")==0){
    printArg(stdout);
    exit(0);
  }

  nInd = angsd::getArg("-nInd",nInd,arguments);
  if(strcmp("dummy",fname)==0 && nInd==0){
    fprintf(stderr,"Must supply -nInd when using simfiles\n");
    printArg(arguments->argumentFile);
  }
  
  printArg(arguments->argumentFile);
}


void reader_sim::init(argStruct *as){
  getOptions(as);
  gz = getGz(fname,"r");
}

void reader_sim::printArg(FILE *argFile){
  fprintf(argFile,"reader_sim:\n\n");
  fprintf(argFile,"-sim1\t%s\n",fname);
  fprintf(argFile,"-nInd\t%d\n",nInd);
  fprintf(argFile,"\n");

}




funkyPars *reader_sim::fetch(int chunkSize){

  funkyPars *r = allocFunkyPars();  
  r->likes=new double*[chunkSize];
  r->sites=new loci[chunkSize];
  r->anc = new char[chunkSize];
  
  static int pos = 0;
  int i;

  for(i=0;i<chunkSize;i++){
    //    fprintf(stderr,"fechgingigngng\n");
    double *lk = new double [10*nInd];
    size_t bytesRead = gzread(gz,lk,sizeof(double)*10*nInd);
    if(bytesRead==0){
      delete [] lk;
      break;
    }else if(bytesRead!=sizeof(double)*10*nInd){
      fprintf(stderr,"\t-> Error reading full chunk\n");
      exit(0);
    }else{ 
      r->likes[i] = lk;
      r->sites[i].chromo = strdup("dummy1");
      r->sites[i].position = i+pos;
      r->anc[i] = 0;
    }
  }
  if(i==0){
    //the code below is
   


    //    delete r->covStruct; //DRAGON move to methods class
    delete r->results->asso;
    delete r->results->freq;
    delete r->results; 
    delete [] r->likes;
    delete [] r->sites;
    delete [] r->anc;
    delete r;
    return NULL;
  }
  r->nInd=nInd;
  r->numSites=i;
  pos += i;
  
  return r;
}

